<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:49 JST 2014 -->
<TITLE>
QuorumPeer
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="QuorumPeer";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumMXBean.html" title="interface in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/QuorumPeer.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="QuorumPeer.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper.server.quorum</FONT>
<BR>
Class QuorumPeer</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by ">java.lang.Thread
      <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.server.quorum.QuorumPeer</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD>java.lang.Runnable, <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html" title="interface in org.apache.zookeeper.server.quorum">QuorumStats.Provider</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public class <B>QuorumPeer</B><DT>extends java.lang.Thread<DT>implements <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html" title="interface in org.apache.zookeeper.server.quorum">QuorumStats.Provider</A></DL>
</PRE>

<P>
This class manages the quorum protocol. There are three states this server
 can be in:
 <ol>
 <li>Leader election - each server will elect a leader (proposing itself as a
 leader initially).</li>
 <li>Follower - the server will synchronize with the leader and replicate any
 transactions.</li>
 <li>Leader - the server will process requests and forward them to followers.
 A majority of followers must log the request before it can be accepted.
 </ol>

 This class will setup a datagram socket that will always respond with its
 view of the current leader. The response will take the form of:

 <pre>
 int xid;

 long myid;

 long leader_id;

 long leader_zxid;
 </pre>

 The request for the current leader will consist solely of an xid: int xid;
<P>

<P>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.ServerState.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.ServerState</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<A NAME="nested_classes_inherited_from_class_java.lang.Thread"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Nested classes/interfaces inherited from class java.lang.Thread</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>java.lang.Thread.State, java.lang.Thread.UncaughtExceptionHandler</CODE></TD>
</TR>
</TABLE>
&nbsp;
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#ACCEPTED_EPOCH_FILENAME">ACCEPTED_EPOCH_FILENAME</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#CURRENT_EPOCH_FILENAME">CURRENT_EPOCH_FILENAME</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#end_fle">end_fle</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Follower.html" title="class in org.apache.zookeeper.server.quorum">Follower</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#follower">follower</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#initLimit">initLimit</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The number of ticks that the initial synchronization phase can take</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html" title="class in org.apache.zookeeper.server.quorum">Leader</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#leader">leader</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#maxSessionTimeout">maxSessionTimeout</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Maximum number of milliseconds to allow for session timeout.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#minSessionTimeout">minSessionTimeout</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Minimum number of milliseconds to allow for session timeout.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Observer.html" title="class in org.apache.zookeeper.server.quorum">Observer</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#observer">observer</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#quorumListenOnAllIPs">quorumListenOnAllIPs</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Whether or not to listen on all IPs for the two quorum ports
 (broadcast and fast leader election).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#quorumPeers">quorumPeers</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The servers that make up the cluster</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#start_fle">start_fle</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#SYNC_ENABLED">SYNC_ENABLED</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The syncEnabled can also be set via a system property.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#syncEnabled">syncEnabled</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Enables/Disables sync request processor.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#syncLimit">syncLimit</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The number of ticks that can pass between sending a request and getting
 an acknowledgment</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#tick">tick</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The current tick</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#tickTime">tickTime</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The number of milliseconds of each tick</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#UPDATING_EPOCH_FILENAME">UPDATING_EPOCH_FILENAME</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<A NAME="fields_inherited_from_class_java.lang.Thread"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Fields inherited from class java.lang.Thread</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>MAX_PRIORITY, MIN_PRIORITY, NORM_PRIORITY</CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="fields_inherited_from_class_org.apache.zookeeper.server.quorum.QuorumStats.Provider"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Fields inherited from interface org.apache.zookeeper.server.quorum.<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html" title="interface in org.apache.zookeeper.server.quorum">QuorumStats.Provider</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#FOLLOWING_STATE">FOLLOWING_STATE</A>, <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#LEADING_STATE">LEADING_STATE</A>, <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#LOOKING_STATE">LOOKING_STATE</A>, <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#OBSERVING_STATE">OBSERVING_STATE</A>, <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#UNKNOWN_STATE">UNKNOWN_STATE</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#QuorumPeer()">QuorumPeer</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#QuorumPeer(java.util.Map, java.io.File, java.io.File, int, int, long, int, int, int)">QuorumPeer</A></B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
           java.io.File&nbsp;snapDir,
           java.io.File&nbsp;logDir,
           int&nbsp;clientPort,
           int&nbsp;electionAlg,
           long&nbsp;myid,
           int&nbsp;tickTime,
           int&nbsp;initLimit,
           int&nbsp;syncLimit)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This constructor is only used by the existing unit test code.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#QuorumPeer(java.util.Map, java.io.File, java.io.File, int, int, long, int, int, int, org.apache.zookeeper.server.quorum.flexible.QuorumVerifier)">QuorumPeer</A></B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
           java.io.File&nbsp;snapDir,
           java.io.File&nbsp;logDir,
           int&nbsp;clientPort,
           int&nbsp;electionAlg,
           long&nbsp;myid,
           int&nbsp;tickTime,
           int&nbsp;initLimit,
           int&nbsp;syncLimit,
           org.apache.zookeeper.server.quorum.flexible.QuorumVerifier&nbsp;quorumConfig)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This constructor is only used by the existing unit test code.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#QuorumPeer(java.util.Map, java.io.File, java.io.File, int, long, int, int, int, boolean, org.apache.zookeeper.server.ServerCnxnFactory, org.apache.zookeeper.server.quorum.flexible.QuorumVerifier)">QuorumPeer</A></B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
           java.io.File&nbsp;dataDir,
           java.io.File&nbsp;dataLogDir,
           int&nbsp;electionType,
           long&nbsp;myid,
           int&nbsp;tickTime,
           int&nbsp;initLimit,
           int&nbsp;syncLimit,
           boolean&nbsp;quorumListenOnAllIPs,
           <A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A>&nbsp;cnxnFactory,
           org.apache.zookeeper.server.quorum.flexible.QuorumVerifier&nbsp;quorumConfig)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#QuorumPeer(java.util.Map, java.io.File, java.io.File, int, long, int, int, int, org.apache.zookeeper.server.ServerCnxnFactory)">QuorumPeer</A></B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
           java.io.File&nbsp;dataDir,
           java.io.File&nbsp;dataLogDir,
           int&nbsp;electionType,
           long&nbsp;myid,
           int&nbsp;tickTime,
           int&nbsp;initLimit,
           int&nbsp;syncLimit,
           <A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A>&nbsp;cnxnFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;For backward compatibility purposes, we instantiate QuorumMaj by default.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#countParticipants(java.util.Map)">countParticipants</A></B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;peers)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Count the number of nodes in the map that could be followers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#createElectionAlgorithm(int)">createElectionAlgorithm</A></B>(int&nbsp;electionAlgorithm)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getAcceptedEpoch()">getAcceptedEpoch</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/ZooKeeperServer.html" title="class in org.apache.zookeeper.server">ZooKeeperServer</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getActiveServer()">getActiveServer</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getClientPort()">getClientPort</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getCnxnFactory()">getCnxnFactory</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getCurrentEpoch()">getCurrentEpoch</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getCurrentVote()">getCurrentVote</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getElectionAlg()">getElectionAlg</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get an instance of LeaderElection</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getElectionType()">getElectionType</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Gets the election type</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getId()">getId</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get the id of this quorum peer.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getInitLimit()">getInitLimit</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get the number of ticks that the initial synchronization phase can take</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getLastLoggedZxid()">getLastLoggedZxid</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;returns the highest zxid that this host has seen</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getLearnerType()">getLearnerType</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getMaxClientCnxnsPerHost()">getMaxClientCnxnsPerHost</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Maximum number of connections allowed from particular host (ip)</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getMaxSessionTimeout()">getMaxSessionTimeout</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maximum session timeout in milliseconds</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getMinSessionTimeout()">getMinSessionTimeout</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;minimum session timeout in milliseconds</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getMyid()">getMyid</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get the id of this quorum peer.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getObservingView()">getObservingView</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns only observers, no followers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.ServerState.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.ServerState</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getPeerState()">getPeerState</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.net.InetSocketAddress</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getQuorumAddress()">getQuorumAddress</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getQuorumCnxManager()">getQuorumCnxManager</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get reference to QuorumCnxManager</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getQuorumListenOnAllIPs()">getQuorumListenOnAllIPs</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getQuorumPeers()">getQuorumPeers</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Only used by QuorumStats at the moment</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getQuorumSize()">getQuorumSize</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;org.apache.zookeeper.server.quorum.flexible.QuorumVerifier</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getQuorumVerifier()">getQuorumVerifier</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return QuorumVerifier object</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getServerState()">getServerState</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getSyncEnabled()">getSyncEnabled</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return syncEnabled.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getSyncLimit()">getSyncLimit</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get the synclimit</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getTick()">getTick</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get the current tick</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getTickTime()">getTickTime</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get the number of milliseconds of each tick</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;org.apache.zookeeper.server.persistence.FileTxnSnapLog</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getTxnFactory()">getTxnFactory</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getView()">getView</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;A 'view' is a node's current opinion of the membership of the entire
 ensemble.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#getVotingView()">getVotingView</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Observers are not contained in this view, only nodes with 
 PeerType=PARTICIPANT.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#isRunning()">isRunning</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Follower.html" title="class in org.apache.zookeeper.server.quorum">Follower</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#makeFollower(org.apache.zookeeper.server.persistence.FileTxnSnapLog)">makeFollower</A></B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;logFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html" title="class in org.apache.zookeeper.server.quorum">Leader</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#makeLeader(org.apache.zookeeper.server.persistence.FileTxnSnapLog)">makeLeader</A></B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;logFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#makeLEStrategy()">makeLEStrategy</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Observer.html" title="class in org.apache.zookeeper.server.quorum">Observer</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#makeObserver(org.apache.zookeeper.server.persistence.FileTxnSnapLog)">makeObserver</A></B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;logFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#run()">run</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setAcceptedEpoch(long)">setAcceptedEpoch</A></B>(long&nbsp;e)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setClientPortAddress(java.net.InetSocketAddress)">setClientPortAddress</A></B>(java.net.InetSocketAddress&nbsp;addr)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setCnxnFactory(org.apache.zookeeper.server.ServerCnxnFactory)">setCnxnFactory</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A>&nbsp;cnxnFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setCurrentEpoch(long)">setCurrentEpoch</A></B>(long&nbsp;e)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setCurrentVote(org.apache.zookeeper.server.quorum.Vote)">setCurrentVote</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&nbsp;v)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setElectionType(int)">setElectionType</A></B>(int&nbsp;electionType)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Sets the election type</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setFollower(org.apache.zookeeper.server.quorum.Follower)">setFollower</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Follower.html" title="class in org.apache.zookeeper.server.quorum">Follower</A>&nbsp;newFollower)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setInitLimit(int)">setInitLimit</A></B>(int&nbsp;initLimit)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Set the number of ticks that the initial synchronization phase can take</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setLeader(org.apache.zookeeper.server.quorum.Leader)">setLeader</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html" title="class in org.apache.zookeeper.server.quorum">Leader</A>&nbsp;newLeader)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setLearnerType(org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType)">setLearnerType</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A>&nbsp;p)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Sets the LearnerType both in the QuorumPeer and in the peerMap</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setMaxSessionTimeout(int)">setMaxSessionTimeout</A></B>(int&nbsp;max)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;minimum session timeout in milliseconds</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setMinSessionTimeout(int)">setMinSessionTimeout</A></B>(int&nbsp;min)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;minimum session timeout in milliseconds</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setMyid(long)">setMyid</A></B>(long&nbsp;myid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;set the id of this quorum peer.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setObserver(org.apache.zookeeper.server.quorum.Observer)">setObserver</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Observer.html" title="class in org.apache.zookeeper.server.quorum">Observer</A>&nbsp;newObserver)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setPeerState(org.apache.zookeeper.server.quorum.QuorumPeer.ServerState)">setPeerState</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.ServerState.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.ServerState</A>&nbsp;newState)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setQuorumListenOnAllIPs(boolean)">setQuorumListenOnAllIPs</A></B>(boolean&nbsp;quorumListenOnAllIPs)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setQuorumPeers(java.util.Map)">setQuorumPeers</A></B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setQuorumVerifier(org.apache.zookeeper.server.quorum.flexible.QuorumVerifier)">setQuorumVerifier</A></B>(org.apache.zookeeper.server.quorum.flexible.QuorumVerifier&nbsp;quorumConfig)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setRunning(boolean)">setRunning</A></B>(boolean&nbsp;running)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setSyncEnabled(boolean)">setSyncEnabled</A></B>(boolean&nbsp;syncEnabled)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Set syncEnabled.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setSyncLimit(int)">setSyncLimit</A></B>(int&nbsp;syncLimit)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Set the synclimit</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setTickTime(int)">setTickTime</A></B>(int&nbsp;tickTime)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Set the number of milliseconds of each tick</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setTxnFactory(org.apache.zookeeper.server.persistence.FileTxnSnapLog)">setTxnFactory</A></B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;factory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#setZKDatabase(org.apache.zookeeper.server.ZKDatabase)">setZKDatabase</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/ZKDatabase.html" title="class in org.apache.zookeeper.server">ZKDatabase</A>&nbsp;database)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;set zk database for this node</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#shutdown()">shutdown</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#start()">start</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#startLeaderElection()">startLeaderElection</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#stopLeaderElection()">stopLeaderElection</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#updateElectionVote(long)">updateElectionVote</A></B>(long&nbsp;newEpoch)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Updates leader election info to avoid inconsistencies when
 a new server tries to join the ensemble.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html#viewContains(java.lang.Long)">viewContains</A></B>(java.lang.Long&nbsp;sid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Check if a node is in the current view.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Thread"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Thread</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>activeCount, checkAccess, clone, countStackFrames, currentThread, destroy, dumpStack, enumerate, getAllStackTraces, getContextClassLoader, getDefaultUncaughtExceptionHandler, getName, getPriority, getStackTrace, getState, getThreadGroup, getUncaughtExceptionHandler, holdsLock, interrupt, interrupted, isAlive, isDaemon, isInterrupted, join, join, join, resume, setContextClassLoader, setDaemon, setDefaultUncaughtExceptionHandler, setName, setPriority, setUncaughtExceptionHandler, sleep, sleep, stop, stop, suspend, toString, yield</CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="start_fle"><!-- --></A><H3>
start_fle</H3>
<PRE>
public long <B>start_fle</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="end_fle"><!-- --></A><H3>
end_fle</H3>
<PRE>
public long <B>end_fle</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="quorumPeers"><!-- --></A><H3>
quorumPeers</H3>
<PRE>
protected java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt; <B>quorumPeers</B></PRE>
<DL>
<DD>The servers that make up the cluster
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="tickTime"><!-- --></A><H3>
tickTime</H3>
<PRE>
protected int <B>tickTime</B></PRE>
<DL>
<DD>The number of milliseconds of each tick
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="minSessionTimeout"><!-- --></A><H3>
minSessionTimeout</H3>
<PRE>
protected int <B>minSessionTimeout</B></PRE>
<DL>
<DD>Minimum number of milliseconds to allow for session timeout.
 A value of -1 indicates unset, use default.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="maxSessionTimeout"><!-- --></A><H3>
maxSessionTimeout</H3>
<PRE>
protected int <B>maxSessionTimeout</B></PRE>
<DL>
<DD>Maximum number of milliseconds to allow for session timeout.
 A value of -1 indicates unset, use default.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="initLimit"><!-- --></A><H3>
initLimit</H3>
<PRE>
protected int <B>initLimit</B></PRE>
<DL>
<DD>The number of ticks that the initial synchronization phase can take
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="syncLimit"><!-- --></A><H3>
syncLimit</H3>
<PRE>
protected int <B>syncLimit</B></PRE>
<DL>
<DD>The number of ticks that can pass between sending a request and getting
 an acknowledgment
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="syncEnabled"><!-- --></A><H3>
syncEnabled</H3>
<PRE>
protected boolean <B>syncEnabled</B></PRE>
<DL>
<DD>Enables/Disables sync request processor. This option is enabled
 by default and is to be used with observers.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="tick"><!-- --></A><H3>
tick</H3>
<PRE>
protected volatile int <B>tick</B></PRE>
<DL>
<DD>The current tick
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="quorumListenOnAllIPs"><!-- --></A><H3>
quorumListenOnAllIPs</H3>
<PRE>
protected boolean <B>quorumListenOnAllIPs</B></PRE>
<DL>
<DD>Whether or not to listen on all IPs for the two quorum ports
 (broadcast and fast leader election).
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="follower"><!-- --></A><H3>
follower</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Follower.html" title="class in org.apache.zookeeper.server.quorum">Follower</A> <B>follower</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="leader"><!-- --></A><H3>
leader</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html" title="class in org.apache.zookeeper.server.quorum">Leader</A> <B>leader</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="observer"><!-- --></A><H3>
observer</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Observer.html" title="class in org.apache.zookeeper.server.quorum">Observer</A> <B>observer</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="SYNC_ENABLED"><!-- --></A><H3>
SYNC_ENABLED</H3>
<PRE>
public static final java.lang.String <B>SYNC_ENABLED</B></PRE>
<DL>
<DD>The syncEnabled can also be set via a system property.
<P>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.QuorumPeer.SYNC_ENABLED">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="CURRENT_EPOCH_FILENAME"><!-- --></A><H3>
CURRENT_EPOCH_FILENAME</H3>
<PRE>
public static final java.lang.String <B>CURRENT_EPOCH_FILENAME</B></PRE>
<DL>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.QuorumPeer.CURRENT_EPOCH_FILENAME">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="ACCEPTED_EPOCH_FILENAME"><!-- --></A><H3>
ACCEPTED_EPOCH_FILENAME</H3>
<PRE>
public static final java.lang.String <B>ACCEPTED_EPOCH_FILENAME</B></PRE>
<DL>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.QuorumPeer.ACCEPTED_EPOCH_FILENAME">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="UPDATING_EPOCH_FILENAME"><!-- --></A><H3>
UPDATING_EPOCH_FILENAME</H3>
<PRE>
public static final java.lang.String <B>UPDATING_EPOCH_FILENAME</B></PRE>
<DL>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../../constant-values.html#org.apache.zookeeper.server.quorum.QuorumPeer.UPDATING_EPOCH_FILENAME">Constant Field Values</A></DL>
</DL>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="QuorumPeer()"><!-- --></A><H3>
QuorumPeer</H3>
<PRE>
public <B>QuorumPeer</B>()</PRE>
<DL>
</DL>
<HR>

<A NAME="QuorumPeer(java.util.Map, java.io.File, java.io.File, int, long, int, int, int, org.apache.zookeeper.server.ServerCnxnFactory)"><!-- --></A><H3>
QuorumPeer</H3>
<PRE>
public <B>QuorumPeer</B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
                  java.io.File&nbsp;dataDir,
                  java.io.File&nbsp;dataLogDir,
                  int&nbsp;electionType,
                  long&nbsp;myid,
                  int&nbsp;tickTime,
                  int&nbsp;initLimit,
                  int&nbsp;syncLimit,
                  <A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A>&nbsp;cnxnFactory)
           throws java.io.IOException</PRE>
<DL>
<DD>For backward compatibility purposes, we instantiate QuorumMaj by default.
<P>
<DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>
<HR>

<A NAME="QuorumPeer(java.util.Map, java.io.File, java.io.File, int, long, int, int, int, boolean, org.apache.zookeeper.server.ServerCnxnFactory, org.apache.zookeeper.server.quorum.flexible.QuorumVerifier)"><!-- --></A><H3>
QuorumPeer</H3>
<PRE>
public <B>QuorumPeer</B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
                  java.io.File&nbsp;dataDir,
                  java.io.File&nbsp;dataLogDir,
                  int&nbsp;electionType,
                  long&nbsp;myid,
                  int&nbsp;tickTime,
                  int&nbsp;initLimit,
                  int&nbsp;syncLimit,
                  boolean&nbsp;quorumListenOnAllIPs,
                  <A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A>&nbsp;cnxnFactory,
                  org.apache.zookeeper.server.quorum.flexible.QuorumVerifier&nbsp;quorumConfig)
           throws java.io.IOException</PRE>
<DL>
<DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>
<HR>

<A NAME="QuorumPeer(java.util.Map, java.io.File, java.io.File, int, int, long, int, int, int)"><!-- --></A><H3>
QuorumPeer</H3>
<PRE>
public <B>QuorumPeer</B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
                  java.io.File&nbsp;snapDir,
                  java.io.File&nbsp;logDir,
                  int&nbsp;clientPort,
                  int&nbsp;electionAlg,
                  long&nbsp;myid,
                  int&nbsp;tickTime,
                  int&nbsp;initLimit,
                  int&nbsp;syncLimit)
           throws java.io.IOException</PRE>
<DL>
<DD>This constructor is only used by the existing unit test code.
 It defaults to FileLogProvider persistence provider.
<P>
<DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>
<HR>

<A NAME="QuorumPeer(java.util.Map, java.io.File, java.io.File, int, int, long, int, int, int, org.apache.zookeeper.server.quorum.flexible.QuorumVerifier)"><!-- --></A><H3>
QuorumPeer</H3>
<PRE>
public <B>QuorumPeer</B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers,
                  java.io.File&nbsp;snapDir,
                  java.io.File&nbsp;logDir,
                  int&nbsp;clientPort,
                  int&nbsp;electionAlg,
                  long&nbsp;myid,
                  int&nbsp;tickTime,
                  int&nbsp;initLimit,
                  int&nbsp;syncLimit,
                  org.apache.zookeeper.server.quorum.flexible.QuorumVerifier&nbsp;quorumConfig)
           throws java.io.IOException</PRE>
<DL>
<DD>This constructor is only used by the existing unit test code.
 It defaults to FileLogProvider persistence provider.
<P>
<DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getLearnerType()"><!-- --></A><H3>
getLearnerType</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A> <B>getLearnerType</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setLearnerType(org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType)"><!-- --></A><H3>
setLearnerType</H3>
<PRE>
public void <B>setLearnerType</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.LearnerType</A>&nbsp;p)</PRE>
<DL>
<DD>Sets the LearnerType both in the QuorumPeer and in the peerMap
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumSize()"><!-- --></A><H3>
getQuorumSize</H3>
<PRE>
public int <B>getQuorumSize</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getId()"><!-- --></A><H3>
getId</H3>
<PRE>
public long <B>getId</B>()</PRE>
<DL>
<DD>get the id of this quorum peer.
<P>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE>getId</CODE> in class <CODE>java.lang.Thread</CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getCurrentVote()"><!-- --></A><H3>
getCurrentVote</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A> <B>getCurrentVote</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setCurrentVote(org.apache.zookeeper.server.quorum.Vote)"><!-- --></A><H3>
setCurrentVote</H3>
<PRE>
public void <B>setCurrentVote</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&nbsp;v)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setPeerState(org.apache.zookeeper.server.quorum.QuorumPeer.ServerState)"><!-- --></A><H3>
setPeerState</H3>
<PRE>
public void <B>setPeerState</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.ServerState.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.ServerState</A>&nbsp;newState)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getPeerState()"><!-- --></A><H3>
getPeerState</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.ServerState.html" title="enum in org.apache.zookeeper.server.quorum">QuorumPeer.ServerState</A> <B>getPeerState</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumAddress()"><!-- --></A><H3>
getQuorumAddress</H3>
<PRE>
public java.net.InetSocketAddress <B>getQuorumAddress</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="start()"><!-- --></A><H3>
start</H3>
<PRE>
public void <B>start</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE>start</CODE> in class <CODE>java.lang.Thread</CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="stopLeaderElection()"><!-- --></A><H3>
stopLeaderElection</H3>
<PRE>
public void <B>stopLeaderElection</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="startLeaderElection()"><!-- --></A><H3>
startLeaderElection</H3>
<PRE>
public void <B>startLeaderElection</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="countParticipants(java.util.Map)"><!-- --></A><H3>
countParticipants</H3>
<PRE>
protected static int <B>countParticipants</B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;peers)</PRE>
<DL>
<DD>Count the number of nodes in the map that could be followers.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>peers</CODE> - 
<DT><B>Returns:</B><DD>The number of followers in the map</DL>
</DD>
</DL>
<HR>

<A NAME="getLastLoggedZxid()"><!-- --></A><H3>
getLastLoggedZxid</H3>
<PRE>
public long <B>getLastLoggedZxid</B>()</PRE>
<DL>
<DD>returns the highest zxid that this host has seen
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the highest zxid for this host</DL>
</DD>
</DL>
<HR>

<A NAME="makeFollower(org.apache.zookeeper.server.persistence.FileTxnSnapLog)"><!-- --></A><H3>
makeFollower</H3>
<PRE>
protected <A HREF="../../../../../org/apache/zookeeper/server/quorum/Follower.html" title="class in org.apache.zookeeper.server.quorum">Follower</A> <B>makeFollower</B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;logFactory)
                         throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="makeLeader(org.apache.zookeeper.server.persistence.FileTxnSnapLog)"><!-- --></A><H3>
makeLeader</H3>
<PRE>
protected <A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html" title="class in org.apache.zookeeper.server.quorum">Leader</A> <B>makeLeader</B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;logFactory)
                     throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="makeObserver(org.apache.zookeeper.server.persistence.FileTxnSnapLog)"><!-- --></A><H3>
makeObserver</H3>
<PRE>
protected <A HREF="../../../../../org/apache/zookeeper/server/quorum/Observer.html" title="class in org.apache.zookeeper.server.quorum">Observer</A> <B>makeObserver</B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;logFactory)
                         throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="createElectionAlgorithm(int)"><!-- --></A><H3>
createElectionAlgorithm</H3>
<PRE>
protected <A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A> <B>createElectionAlgorithm</B>(int&nbsp;electionAlgorithm)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="makeLEStrategy()"><!-- --></A><H3>
makeLEStrategy</H3>
<PRE>
protected <A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A> <B>makeLEStrategy</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setLeader(org.apache.zookeeper.server.quorum.Leader)"><!-- --></A><H3>
setLeader</H3>
<PRE>
protected void <B>setLeader</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Leader.html" title="class in org.apache.zookeeper.server.quorum">Leader</A>&nbsp;newLeader)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setFollower(org.apache.zookeeper.server.quorum.Follower)"><!-- --></A><H3>
setFollower</H3>
<PRE>
protected void <B>setFollower</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Follower.html" title="class in org.apache.zookeeper.server.quorum">Follower</A>&nbsp;newFollower)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setObserver(org.apache.zookeeper.server.quorum.Observer)"><!-- --></A><H3>
setObserver</H3>
<PRE>
protected void <B>setObserver</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/Observer.html" title="class in org.apache.zookeeper.server.quorum">Observer</A>&nbsp;newObserver)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getActiveServer()"><!-- --></A><H3>
getActiveServer</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/ZooKeeperServer.html" title="class in org.apache.zookeeper.server">ZooKeeperServer</A> <B>getActiveServer</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="run()"><!-- --></A><H3>
run</H3>
<PRE>
public void <B>run</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE>run</CODE> in interface <CODE>java.lang.Runnable</CODE><DT><B>Overrides:</B><DD><CODE>run</CODE> in class <CODE>java.lang.Thread</CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="shutdown()"><!-- --></A><H3>
shutdown</H3>
<PRE>
public void <B>shutdown</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getView()"><!-- --></A><H3>
getView</H3>
<PRE>
public java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt; <B>getView</B>()</PRE>
<DL>
<DD>A 'view' is a node's current opinion of the membership of the entire
 ensemble.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getVotingView()"><!-- --></A><H3>
getVotingView</H3>
<PRE>
public java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt; <B>getVotingView</B>()</PRE>
<DL>
<DD>Observers are not contained in this view, only nodes with 
 PeerType=PARTICIPANT.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getObservingView()"><!-- --></A><H3>
getObservingView</H3>
<PRE>
public java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt; <B>getObservingView</B>()</PRE>
<DL>
<DD>Returns only observers, no followers.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="viewContains(java.lang.Long)"><!-- --></A><H3>
viewContains</H3>
<PRE>
public boolean <B>viewContains</B>(java.lang.Long&nbsp;sid)</PRE>
<DL>
<DD>Check if a node is in the current view. With static membership, the
 result of this check will never change; only when dynamic membership
 is introduced will this be more useful.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumPeers()"><!-- --></A><H3>
getQuorumPeers</H3>
<PRE>
public java.lang.String[] <B>getQuorumPeers</B>()</PRE>
<DL>
<DD>Only used by QuorumStats at the moment
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#getQuorumPeers()">getQuorumPeers</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html" title="interface in org.apache.zookeeper.server.quorum">QuorumStats.Provider</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getServerState()"><!-- --></A><H3>
getServerState</H3>
<PRE>
public java.lang.String <B>getServerState</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html#getServerState()">getServerState</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumStats.Provider.html" title="interface in org.apache.zookeeper.server.quorum">QuorumStats.Provider</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getMyid()"><!-- --></A><H3>
getMyid</H3>
<PRE>
public long <B>getMyid</B>()</PRE>
<DL>
<DD>get the id of this quorum peer.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setMyid(long)"><!-- --></A><H3>
setMyid</H3>
<PRE>
public void <B>setMyid</B>(long&nbsp;myid)</PRE>
<DL>
<DD>set the id of this quorum peer.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getTickTime()"><!-- --></A><H3>
getTickTime</H3>
<PRE>
public int <B>getTickTime</B>()</PRE>
<DL>
<DD>Get the number of milliseconds of each tick
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setTickTime(int)"><!-- --></A><H3>
setTickTime</H3>
<PRE>
public void <B>setTickTime</B>(int&nbsp;tickTime)</PRE>
<DL>
<DD>Set the number of milliseconds of each tick
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getMaxClientCnxnsPerHost()"><!-- --></A><H3>
getMaxClientCnxnsPerHost</H3>
<PRE>
public int <B>getMaxClientCnxnsPerHost</B>()</PRE>
<DL>
<DD>Maximum number of connections allowed from particular host (ip)
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getMinSessionTimeout()"><!-- --></A><H3>
getMinSessionTimeout</H3>
<PRE>
public int <B>getMinSessionTimeout</B>()</PRE>
<DL>
<DD>minimum session timeout in milliseconds
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setMinSessionTimeout(int)"><!-- --></A><H3>
setMinSessionTimeout</H3>
<PRE>
public void <B>setMinSessionTimeout</B>(int&nbsp;min)</PRE>
<DL>
<DD>minimum session timeout in milliseconds
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getMaxSessionTimeout()"><!-- --></A><H3>
getMaxSessionTimeout</H3>
<PRE>
public int <B>getMaxSessionTimeout</B>()</PRE>
<DL>
<DD>maximum session timeout in milliseconds
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setMaxSessionTimeout(int)"><!-- --></A><H3>
setMaxSessionTimeout</H3>
<PRE>
public void <B>setMaxSessionTimeout</B>(int&nbsp;max)</PRE>
<DL>
<DD>minimum session timeout in milliseconds
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getInitLimit()"><!-- --></A><H3>
getInitLimit</H3>
<PRE>
public int <B>getInitLimit</B>()</PRE>
<DL>
<DD>Get the number of ticks that the initial synchronization phase can take
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setInitLimit(int)"><!-- --></A><H3>
setInitLimit</H3>
<PRE>
public void <B>setInitLimit</B>(int&nbsp;initLimit)</PRE>
<DL>
<DD>Set the number of ticks that the initial synchronization phase can take
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getTick()"><!-- --></A><H3>
getTick</H3>
<PRE>
public int <B>getTick</B>()</PRE>
<DL>
<DD>Get the current tick
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumVerifier()"><!-- --></A><H3>
getQuorumVerifier</H3>
<PRE>
public org.apache.zookeeper.server.quorum.flexible.QuorumVerifier <B>getQuorumVerifier</B>()</PRE>
<DL>
<DD>Return QuorumVerifier object
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setQuorumVerifier(org.apache.zookeeper.server.quorum.flexible.QuorumVerifier)"><!-- --></A><H3>
setQuorumVerifier</H3>
<PRE>
public void <B>setQuorumVerifier</B>(org.apache.zookeeper.server.quorum.flexible.QuorumVerifier&nbsp;quorumConfig)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getElectionAlg()"><!-- --></A><H3>
getElectionAlg</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A> <B>getElectionAlg</B>()</PRE>
<DL>
<DD>Get an instance of LeaderElection
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSyncLimit()"><!-- --></A><H3>
getSyncLimit</H3>
<PRE>
public int <B>getSyncLimit</B>()</PRE>
<DL>
<DD>Get the synclimit
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setSyncLimit(int)"><!-- --></A><H3>
setSyncLimit</H3>
<PRE>
public void <B>setSyncLimit</B>(int&nbsp;syncLimit)</PRE>
<DL>
<DD>Set the synclimit
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSyncEnabled()"><!-- --></A><H3>
getSyncEnabled</H3>
<PRE>
public boolean <B>getSyncEnabled</B>()</PRE>
<DL>
<DD>Return syncEnabled.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD></DL>
</DD>
</DL>
<HR>

<A NAME="setSyncEnabled(boolean)"><!-- --></A><H3>
setSyncEnabled</H3>
<PRE>
public void <B>setSyncEnabled</B>(boolean&nbsp;syncEnabled)</PRE>
<DL>
<DD>Set syncEnabled.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>syncEnabled</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="getElectionType()"><!-- --></A><H3>
getElectionType</H3>
<PRE>
public int <B>getElectionType</B>()</PRE>
<DL>
<DD>Gets the election type
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setElectionType(int)"><!-- --></A><H3>
setElectionType</H3>
<PRE>
public void <B>setElectionType</B>(int&nbsp;electionType)</PRE>
<DL>
<DD>Sets the election type
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumListenOnAllIPs()"><!-- --></A><H3>
getQuorumListenOnAllIPs</H3>
<PRE>
public boolean <B>getQuorumListenOnAllIPs</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setQuorumListenOnAllIPs(boolean)"><!-- --></A><H3>
setQuorumListenOnAllIPs</H3>
<PRE>
public void <B>setQuorumListenOnAllIPs</B>(boolean&nbsp;quorumListenOnAllIPs)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getCnxnFactory()"><!-- --></A><H3>
getCnxnFactory</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A> <B>getCnxnFactory</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setCnxnFactory(org.apache.zookeeper.server.ServerCnxnFactory)"><!-- --></A><H3>
setCnxnFactory</H3>
<PRE>
public void <B>setCnxnFactory</B>(<A HREF="../../../../../org/apache/zookeeper/server/ServerCnxnFactory.html" title="class in org.apache.zookeeper.server">ServerCnxnFactory</A>&nbsp;cnxnFactory)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setQuorumPeers(java.util.Map)"><!-- --></A><H3>
setQuorumPeers</H3>
<PRE>
public void <B>setQuorumPeers</B>(java.util.Map&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.QuorumServer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer.QuorumServer</A>&gt;&nbsp;quorumPeers)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getClientPort()"><!-- --></A><H3>
getClientPort</H3>
<PRE>
public int <B>getClientPort</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setClientPortAddress(java.net.InetSocketAddress)"><!-- --></A><H3>
setClientPortAddress</H3>
<PRE>
public void <B>setClientPortAddress</B>(java.net.InetSocketAddress&nbsp;addr)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setTxnFactory(org.apache.zookeeper.server.persistence.FileTxnSnapLog)"><!-- --></A><H3>
setTxnFactory</H3>
<PRE>
public void <B>setTxnFactory</B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;factory)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getTxnFactory()"><!-- --></A><H3>
getTxnFactory</H3>
<PRE>
public org.apache.zookeeper.server.persistence.FileTxnSnapLog <B>getTxnFactory</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setZKDatabase(org.apache.zookeeper.server.ZKDatabase)"><!-- --></A><H3>
setZKDatabase</H3>
<PRE>
public void <B>setZKDatabase</B>(<A HREF="../../../../../org/apache/zookeeper/server/ZKDatabase.html" title="class in org.apache.zookeeper.server">ZKDatabase</A>&nbsp;database)</PRE>
<DL>
<DD>set zk database for this node
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>database</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="setRunning(boolean)"><!-- --></A><H3>
setRunning</H3>
<PRE>
public void <B>setRunning</B>(boolean&nbsp;running)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="isRunning()"><!-- --></A><H3>
isRunning</H3>
<PRE>
public boolean <B>isRunning</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumCnxManager()"><!-- --></A><H3>
getQuorumCnxManager</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager</A> <B>getQuorumCnxManager</B>()</PRE>
<DL>
<DD>get reference to QuorumCnxManager
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getCurrentEpoch()"><!-- --></A><H3>
getCurrentEpoch</H3>
<PRE>
public long <B>getCurrentEpoch</B>()
                     throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="getAcceptedEpoch()"><!-- --></A><H3>
getAcceptedEpoch</H3>
<PRE>
public long <B>getAcceptedEpoch</B>()
                      throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="setCurrentEpoch(long)"><!-- --></A><H3>
setCurrentEpoch</H3>
<PRE>
public void <B>setCurrentEpoch</B>(long&nbsp;e)
                     throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="setAcceptedEpoch(long)"><!-- --></A><H3>
setAcceptedEpoch</H3>
<PRE>
public void <B>setAcceptedEpoch</B>(long&nbsp;e)
                      throws java.io.IOException</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="updateElectionVote(long)"><!-- --></A><H3>
updateElectionVote</H3>
<PRE>
protected void <B>updateElectionVote</B>(long&nbsp;newEpoch)</PRE>
<DL>
<DD>Updates leader election info to avoid inconsistencies when
 a new server tries to join the ensemble.
 See ZOOKEEPER-1732 for more info.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumMXBean.html" title="interface in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.LearnerType.html" title="enum in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/QuorumPeer.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="QuorumPeer.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
